<*+ O2EXTENSIONS *>
<*+ MAIN *>
<*+ O2 *>
<*+ CHANGESYM *>

MODULE Generic;

IMPORT SYSTEM;
IMPORT W := Windows;
IMPORT WinUser, WinDef;
IMPORT CC := CommCtrl;

CONST AppName = "Generic";
      Title   = AppName + " Application";
      IDC_MAIN_STATUS   = 103;

(* Resource identifiers (sorry, can't include .h files *)

CONST IDM_NEW         = 100;
      IDM_OPEN        = 101;
      IDM_SAVE        = 102;
      IDM_SAVEAS      = 103;
      IDM_PRINT       = 104;
      IDM_PRINTSETUP  = 105;
      IDM_EXIT        = 106;
      IDM_UNDO        = 200;
      IDM_CUT         = 201;
      IDM_COPY        = 202;

      IDM_PASTE       = 203;
      IDM_LINK        = 204;
      IDM_LINKS       = 205;

CONST IDSTR_FILTER    = 1000;

VAR
  hwndSB: W.HWND;

PROCEDURE OpenFile (owner : W.HWND);
VAR
    filter : ARRAY 999 OF CHAR;
    of : W.OPENFILENAME;
    file : ARRAY 999 OF CHAR;
    s    : ARRAY 1099 OF CHAR;

CONST DefExt = "";
      Title  = "Select file to open";
BEGIN
    SYSTEM.FILL (SYSTEM.ADR (filter), 0, SIZE (filter));
    W.LoadString (W.GetModuleHandle(NIL), IDSTR_FILTER, filter, SIZE (filter));
    file [0] := 0C;

    SYSTEM.FILL (SYSTEM.ADR (of), 0, SIZE (of));
    of.lStructSize := SIZE (of);
    of.hwndOwner   := NIL;
    of.lpstrFilter := W.GetPSTR (filter);
    of.lpstrDefExt := W.GetPSTR (DefExt);
    of.lpstrFile   := W.GetPSTR (file);
    of.nMaxFile    := SIZE (file);
    of.lpstrTitle  := W.GetPSTR (Title);
    of.Flags       := W.OFN_HIDEREADONLY;

    IF W.GetOpenFileName (of) THEN
        W.wsprintf (s, "File selected: %s", file);
        W.MessageBox (owner, s, "Open command", W.MB_OK);
    END;
END OpenFile;

PROCEDURE [W.CALLBACK] WndProc (hWnd : W.HWND; message : W.UINT;
                                      wParam : W.WPARAM; lParam : W.LPARAM) : W.LRESULT;

VAR
   wmId : INTEGER;
   ps  : W.PAINTSTRUCT;
   hdc : W.HDC;
   pnt : W.POINT;
   hMenu : W.HMENU;
   hBrush : W.HBRUSH;
   rect : W.RECT;
   arrWidthsSB: ARRAY 6 OF INTEGER;
   style: W.WS_SET;
   str: ARRAY 100 OF CHAR;
BEGIN
    CASE message OF
    | W.WM_CREATE:
         hMenu := W.GetMenu (hWnd);
         W.EnableMenuItem (hMenu, IDM_NEW, W.MF_ENABLED+W.MF_BYCOMMAND);
         W.EnableMenuItem (hMenu, IDM_OPEN, W.MF_ENABLED+W.MF_BYCOMMAND);

        style := W.WS_CHILD + W.WS_VISIBLE + W.WS_BORDER
          + W.WS_CLIPSIBLINGS + SYSTEM.VAL (W.WS_SET, CC.SBARS_SIZEGRIP);

        hwndSB := W.CreateWindowEx (W.WS_EX_SET{}, CC.STATUSCLASSNAME, "",
                                W.WS_CHILD + W.WS_VISIBLE,
                                0, 0, 0, 0, hWnd,
                                SYSTEM.VAL (W.HMENU, IDC_MAIN_STATUS), W.MyInstance(), NIL);

        arrWidthsSB[0] := 125;
        arrWidthsSB[1] := 225;
        arrWidthsSB[2] := 325;
        arrWidthsSB[3] := 375;
        arrWidthsSB[4] := 500;
        arrWidthsSB[5] := -1;
        W.SendMessage (hwndSB, CC.SB_SETPARTS, SYSTEM.VAL(W.WPARAM, SIZE(arrWidthsSB) DIV SIZE(INTEGER)), SYSTEM.VAL (W.LPARAM, SYSTEM.M2ADR(arrWidthsSB)));
        W.SendMessage (hwndSB, CC.SB_SETTEXT, 0, SYSTEM.VAL (W.LPARAM, SYSTEM.ADR(str)));
        W.SendMessage (hwndSB, CC.SB_SETTEXT, 0, SYSTEM.VAL (W.LPARAM, W.GetPSTR("Part1...")));
        W.SendMessage (hwndSB, CC.SB_SETTEXT, 1, SYSTEM.VAL (W.LPARAM, W.GetPSTR("Part2...")));

         RETURN 0;
    | W.WM_COMMAND:
         wmId    := W.LOWORD (wParam);

         (* Parse the menu selections: *)

         CASE wmId OF
         | IDM_EXIT:     W.DestroyWindow (hWnd);

         (* These two are not 'real' new and open; they only demonstrate how
          * to react on menu message.
          * Besides, OpenFile procedure demonstrates using of common dialogs
          * (see above)
          *)

         | IDM_NEW:      W.MessageBox (hWnd, "'New' menu item pressed", AppName, W.MB_OK);
         | IDM_OPEN:     OpenFile (hWnd);

         (* Here are all the other possible menu options,
          * all of these are currently disabled:
         *)

         | IDM_SAVE:
         | IDM_SAVEAS:
         | IDM_UNDO:
         | IDM_CUT:
         | IDM_COPY:
         | IDM_PASTE:
         | IDM_LINK:
         | IDM_LINKS:
         ELSE
                         RETURN W.DefWindowProc (hWnd, message, wParam, lParam);
         END;

    | W.WM_RBUTTONDOWN: (* RightClick in windows client area... *)

         pnt.x := W.LOWORD (lParam);
         pnt.y := W.HIWORD (lParam);
         W.ClientToScreen (hWnd, pnt);

         (* This is where you would determine the appropriate 'context'
         ** menu to bring up. Since this app has no real functionality,
         ** we will just bring up the 'File' menu:
         *)

         hMenu := W.GetSubMenu (W.GetMenu (hWnd), 0);
         IF hMenu <> NIL THEN
             W.TrackPopupMenu (hMenu, W.TPM_SET {}, pnt.x, pnt.y, 0, hWnd, NIL);
         ELSE
             W.MessageBeep (W.MB_SET {});
         END;

    | W.WM_PAINT:
         hdc := W.BeginPaint (hWnd, ps);

         (* This is where you should put all your drawing.
          * Just to demonstrate how it should be done we will
          * paint enture client area in light-blue and draw some
          * white string in the center of it
         *)

         hBrush := W.CreateSolidBrush (W.RGB (0, 0, 255));
         W.GetClientRect (hWnd, rect);
         W.FillRect (hdc, rect, hBrush);
         W.DeleteObject (hBrush);
         W.SetTextColor (hdc, W.RGB (255, 255, 255));
         W.SetBkMode (hdc, W.TRANSPARENT);
         W.DrawText (hdc, "Oberon-2 Generic application", -1, rect,
                           W.DT_CENTER + W.DT_VCENTER + W.DT_SINGLELINE);
         W.EndPaint (hWnd, ps);

    | W.WM_DESTROY:
         W.PostQuitMessage (0);
    ELSE
         RETURN W.DefWindowProc (hWnd, message, wParam, lParam);
    END;
    RETURN 0;
END WndProc;

PROCEDURE InitApplication () : BOOLEAN;
VAR wc : W.WNDCLASSEX;
BEGIN

    (* Fill in window class structure with parameters that describe
    ** the main window.
    *)

    wc.style         := W.CS_HREDRAW + W.CS_VREDRAW;
    wc.lpfnWndProc   := WndProc;
    wc.cbClsExtra    := 0;
    wc.cbWndExtra    := 0;
    wc.hInstance     := W.GetModuleHandle(NIL);
    wc.hIcon         := W.LoadIcon (wc.hInstance, AppName);
    wc.hCursor       := W.LoadCursor (NIL, W.IDC_ARROW);
    wc.hbrBackground := NIL; (* No default brush necessary since we handle all the drawing *)
    wc.lpszMenuName  := W.GetPSTR (AppName);
    wc.lpszClassName := W.GetPSTR (AppName);

    (* Added elements for Windows 95: *)

    wc.cbSize  := SIZE (W.WNDCLASSEX);
    wc.hIconSm := W.LoadIcon (wc.hInstance, "SMALL");

    RETURN W.RegisterClassEx (wc) <> 0;
END InitApplication;

PROCEDURE InitMainWindow () : BOOLEAN;
VAR hWnd : W.HWND;
BEGIN
    hWnd := W.CreateWindow (AppName, Title, W.WS_OVERLAPPEDWINDOW,
                                  W.CW_USEDEFAULT, 0, W.CW_USEDEFAULT, 0,
                                  NIL, NIL, W.GetModuleHandle(NIL), NIL);
    IF hWnd = NIL THEN
                RETURN FALSE;
    END;

    W.ShowWindow   (hWnd, W.SW_SHOWDEFAULT);
    W.UpdateWindow (hWnd);
    RETURN TRUE;
END InitMainWindow;

VAR msg : W.MSG;

BEGIN
  CC.InitCommonControls();
    IF InitApplication () AND InitMainWindow () THEN
        WHILE W.GetMessage (msg, NIL, 0, 0) DO
              W.TranslateMessage (msg);
              W.DispatchMessage  (msg);
        END;
    END;
END Generic.

